clear all
cls
version 14
est clear
cap graph drop _all
set type float
set seed 33333
set more off
set logtype text
capture log close
cap program drop bunchbounds
use bunching.dta



*the friction error only exists plus and minus deltap,deltam  around the kink
scalar deltap = ln(1.1)
scalar deltam = -ln(0.9)

*use the tax schedule for one child given on page 190 of Saez (2010);
scalar s0 = log(1-(-0.3))
scalar s1 = log(1-(+0.1))

*kink location
scalar kink =  round(ln(8),0.0001)



*randomly select 10K observations
sample 10000, count


*default run
cap noisily bunchbounds y  [fw = w], k(`=kink')	 m(3) s0(`=s0') s1(`=s1') savingbounds(boundsgraph, replace)



****option of weights
*error: fweightS
cap noisily bunchbounds y  [fweights = w], k(`=kink')	 m(2) s0(`=s0') s1(`=s1') nopic

cap noisily bunchbounds y  [fweight = w], k(`=kink') m(2) s0(`=s0') s1(`=s1') nopic

cap noisily bunchbounds y  [fw = w], k(`=kink') m(2) s0(`=s0') s1(`=s1')



*****sample selection options
cap noisily bunchbounds y  in 1/500 [fw = w], k(`=kink') m(7) s0(`=s0') s1(`=s1') savingbounds(boundsgraph, replace)
preserve
clear
use boundsgraph
sum , d
restore

*Bhat is zero
cap noisily bunchbounds y  if y <`=kink' [fw = w], k(`=kink') m(2) s0(`=s0') s1(`=s1') savingbounds(boundsgraph, replace)


cap noisily bunchbounds y  if y <5 [fw = w], k(`=kink') m(2) s0(`=s0') s1(`=s1') savingbounds(boundsgraph, replace)



***option M needs to be lower case
cap noisily bunchbounds y  [fw = w], k(`=kink') M(2) s0(`=s0') s1(`=s1') nopic




***file already exists
cap noisily bunchbounds y  [fw = w], k(`=kink') m(2) s0(`=s0') s1(`=s1') nopic savingbounds(boundsgraph)

cap noisily bunchbounds y  [fw = w], k(`=kink') m(2) s0(`=s0') s1(`=s1') nopic savingbounds(boundsgraph.dta)

cap noisily bunchbounds y  [fw = w], k(`=kink') m(2) s0(`=s0') s1(`=s1') nopic savingbounds("boundsgraph")

cap noisily bunchbounds y  [fw = w], k(`=kink') m(2) s0(`=s0') s1(`=s1') nopic savingbounds("boundsgraph.dta")


cap noisily bunchbounds y  [fw = w], k(`=kink') m(2) s0(`=s0') s1(`=s1') nopic savingbounds(boundsgraph, replace)


***no weights
cap noisily bunchbounds y , k(`=kink') m(2) s0(`=s0') s1(`=s1') nopic savingbounds(boundsgraph, replace)


***negative or zero slope
cap noisily bunchbounds y  [fw = w], k(`=kink') m(-1) s0(`=s0') s1(`=s1') nopic 

cap noisily bunchbounds y  [fw = w], k(`=kink') m(0) s0(`=s0') s1(`=s1') nopic



****value of M smaller than M_hat 
**bounds do not exist
cap noisily bunchbounds y  [fw = w], k(`=kink') m(0.10) s0(`=s0') s1(`=s1')  savingbounds(boundsgraph, replace)
cap noisily return list
**bounds are finite
cap noisily bunchbounds y  [fw = w], k(`=kink') m(0.25) s0(`=s0') s1(`=s1')  savingbounds(boundsgraph, replace)
cap noisily return list
**upper bound is infinity
cap noisily bunchbounds y  [fw = w], k(`=kink') m(10) s0(`=s0') s1(`=s1')  savingbounds(boundsgraph, replace)
cap noisily return list


***no package lpdensity installed
cap noisily ado dir
cap noisily ado uninstall lpdensity
 

cap noisily bunchbounds y , k(`=kink') m(2) s0(`=s0') s1(`=s1') nopic savingbounds(boundsgraph, replace)

*cap noisily net install lpdensity, from(https://sites.google.com/site/nppackages/lpdensity/stata) replace
net install lpdensity, from(https://raw.githubusercontent.com/nppackages/lpdensity/master/stata) replace

cap noisily bunchbounds y , k(`=kink') m(2) s0(`=s0') s1(`=s1') nopic savingbounds(boundsgraph, replace)
