clear all
cls
version 14
est clear
graph drop _all
scalar drop _all
matrix drop _all
set more off
cap program drop bunchtobit
cap program drop bunchtobit_tloglike
cap program drop bunchbounds
cap program drop bunchfilter
cap program drop bunching

use bunching.dta

*the friction error only exists plus and minus deltap,deltam  around the kink
scalar deltap = ln(1.1)
scalar deltam = -ln(0.9)

*use the tax schedule for one child given on page 190 of Saez (2010);
scalar s0 = log(1-(-0.3))
scalar s1 = log(1-(+0.1))


*kink location
scalar kink =  round(ln(8),0.0001)

*randomly select 10K observations
sample 10000, count




**********default runs
cap rm dtobit.dta
cap rm dbounds.dta
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') savingtobit(dtobit.dta, replace) savingbounds(dbounds.dta, replace)
return list
preserve
drop _all
cap use dbounds
sum , d
drop _all
cap use dtobit
list
restore

cap rm dtobit.dta
cap rm dbounds.dta
cap drop yfiltered
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) savingtobit(dtobit.dta, replace) savingbounds(dbounds, replace)
return list
preserve
drop _all
cap use dbounds
sum ,d 
drop _all
cap use dtobit
list
restore


***** missing a relevant option for filter : gen() deltap() deltam() pol() pct()
*cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') pol(5) pct(50)
cap drop yfiltered

cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 		 deltap(`=deltap') deltam(`=deltam') pol(5) pct(50)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered)  		     deltam(`=deltam') pol(5) pct(50)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') 			 pol(5) pct(50)
*cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') 	    pct(50)
*cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') pol(5) 

cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 					 deltam(`=deltam') pol(5) pct(50)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 		 deltap(`=deltap') 			 pol(5) pct(50)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 		 deltap(`=deltap') deltam(`=deltam') 		pct(50)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 		 deltap(`=deltap') deltam(`=deltam') pol(5) 
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) 						 pol(5) pct(50)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered)  			deltam(`=deltam')  	    pct(50)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) 		    deltam(`=deltam')  pol(5) 
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') 				    pct(50)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap')  			 pol(5) 
*cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') 


cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') 
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) 			 deltam(`=deltam') 
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) 						 pol(5) 
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) 								pct(50)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 		 deltap(`=deltap') deltam(`=deltam')
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 		 deltap(`=deltap') 			 pol(5) 
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 		 deltap(`=deltap') 				 	pct(50)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 					 deltam(`=deltam') pol(5)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 					 deltam(`=deltam') 		pct(50)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 								 pol(5) pct(50)


cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) 
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 		 deltap(`=deltap') 
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 					 deltam(`=deltam') 
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 								 pol(5)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) 										pct(50)


**** option generate : variable already exists 
cap noisily  bunching yfric, generate(yfiltered) k(`=kink') s0(`=s0') s1(`=s1') m(2) deltap(`=deltap') deltam(`=deltam') 

**** option generate : abbreviation
cap drop yfiltered
cap noisily  bunching yfric, gen(yfiltered) k(`=kink') s0(`=s0') s1(`=s1') m(2) deltap(`=deltap') deltam(`=deltam') grid(90) nopic



***** option deltas

*non str positive
cap drop yfiltered
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(-0.3) deltam(`=deltam')
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(-0.3)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(-0.3) deltam(-0.3)


*too big
cap drop yfiltered
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(10) deltam(10)


*deltas are zero
cap drop yfiltered
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(0) deltam(`=deltam')
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(0)
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(0) deltam(0)





*assymetric deltas
cap drop yfiltered
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(0.05) grid(30 90)



cap drop yfiltered
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(0.05) deltam(`=deltam') grid(30 90)



cap drop yfiltered
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(0.6) deltam(`=deltam') grid(30 90)









***** option kink

*error missing
cap drop yfiltered
cap noisily  bunching yfric,  s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)

*abbreviation
cap drop yfiltered
cap noisily  bunching yfric, K(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)
cap noisily  bunching yfric, kink(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)
cap drop yfiltered
cap noisily  bunching yfric, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)




*look for extreme values to move the kink to
sum yfiltered, d
local ymax = r(max)
local ymin = r(min)

*no obs on the left
cap drop yfiltered
cap noisily  bunching yfric, k(`ymin') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)
cap noisily  bunching y, k(`ymin') s0(`=s0') s1(`=s1') m(2)  grid(30 90)


*no obs on the right
cap drop yfiltered
cap noisily  bunching yfric, k(`ymax') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)
cap noisily  bunching y, k(`ymax') s0(`=s0') s1(`=s1') m(2)  grid(30 90)


*point without bunching mass?
cap noisily  bunching y, k(1) s0(`=s0') s1(`=s1') m(2)  grid(30 90)





**********s0 s1 options
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=log(1+(-.5))') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') 
return list

cap drop yfiltered
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=log(1+(-.5))') m(2) 
return list


cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink')  s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') 
return list

cap drop yfiltered
cap noisily bunching y x1 x2 x3,  k(`=kink') s1(`=s1') m(2) 
return list



cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') 
return list

cap drop yfiltered
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') m(2) 
return list




cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=log(1-(-.34))') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') 
return list

cap drop yfiltered
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=log(1-(-.34))') m(2) 
return list





cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=log(1-(-.33))') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)
return list

cap drop yfiltered
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=log(1-(-.33))') m(2) grid(30 90)
return list



 
 
 
 
 

********* option weights
*abbreviation
cap drop yfiltered
cap noisily  bunching yfric [fweights=w], k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)
cap noisily  bunching y [fweights=w], k(`=kink') s0(`=s0') s1(`=s1') m(2)  grid(30 90)

*abbreviation
cap drop yfiltered
cap noisily  bunching yfric [fw=w], k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)

cap drop yfiltered
cap noisily  bunching y [fw=w], k(`=kink') s0(`=s0') s1(`=s1') m(2)  grid(30 90)



*with different weights

gen w2=_n^4

cap drop yfiltered
cap noisily  bunching yfric [fw=w2], k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)


cap drop yfiltered
cap noisily  bunching y [fw=w2], k(`=kink') s0(`=s0') s1(`=s1') m(2)  grid(30 90)
return list














********* sample selection
cap rm dtobit.dta
cap rm dbounds.dta
cap drop yfiltered
cap noisily  bunching yfric if (yfric<`=kink'-`=deltam')|(yfric>`=kink'+`=deltap') , k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90) savingtobit(dtobit.dta, replace) savingbounds(dbounds.dta, replace)
return list
preserve
drop _all
cap use dbounds
sum , d
drop _all
cap use dtobit
list
restore


cap rm dtobit.dta
cap rm dbounds.dta
cap drop yfiltered
cap noisily  bunching y if (y<`=kink'-`=deltam')|(y>`=kink'+`=deltap'), k(`=kink') s0(`=s0') s1(`=s1') m(2)  grid(30 90) savingtobit(dtobit.dta, replace) savingbounds(dbounds.dta, replace)
return list
preserve
drop _all
cap use dbounds
sum , d
drop _all
cap use dtobit
list
restore


cap rm dtobit.dta
cap rm dbounds.dta
cap drop yfiltered
cap noisily  bunching yfric if yfric<`=kink', k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90) savingtobit(dtobit.dta, replace) savingbounds(dbounds.dta, replace)
return list
preserve
drop _all
cap use dbounds
sum , d
drop _all
cap use dtobit
list
restore

cap rm dtobit.dta
cap rm dbounds.dta
cap drop yfiltered
cap noisily  bunching y if y<`=kink', k(`=kink') s0(`=s0') s1(`=s1') m(2)  grid(30 90) savingtobit(dtobit.dta, replace) savingbounds(dbounds.dta, replace)
return list
preserve
drop _all
cap use dbounds
sum , d
drop _all
cap use dtobit
list
restore

cap rm dtobit.dta
cap rm dbounds.dta
cap drop yfiltered
cap noisily  bunching yfric in 1/500, k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90) savingtobit(dtobit.dta, replace) savingbounds(dbounds.dta, replace)
return list
preserve
drop _all
cap use dbounds
sum , d
drop _all
cap use dtobit
list
restore


cap rm dtobit.dta
cap rm dbounds.dta
cap drop yfiltered
cap noisily  bunching y in 1/500 , k(`=kink') s0(`=s0') s1(`=s1') m(2)  grid(30 90) savingtobit(dtobit.dta, replace) savingbounds(dbounds.dta, replace)
return list
preserve
drop _all
cap use dbounds
sum , d
drop _all
cap use dtobit
list
restore




cap rm dtobit.dta
cap rm dbounds.dta
cap drop yfiltered
cap noisily  bunching y if x1==1 , k(`=kink') s0(`=s0') s1(`=s1') m(2)  grid(30 90) savingtobit(dtobit.dta, replace) savingbounds(dbounds.dta, replace)
return list
preserve
drop _all
cap use dbounds
sum , d
drop _all
cap use dtobit
list
restore








*********test option pctobs
*error: invalid numbers
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') pctobs(-1)
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') pctobs(0)
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') pctobs(50.5)
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') pctobs(100)


*abbreviation
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') pct(50) grid(90)


*small value
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') pct(10) grid(90)

*large value
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') pct(99) grid(90)













*********test option polorder
*error: invalid numbers
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') polorder(0)
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') polorder(8)
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') polorder(4.73)



*abbreviation and small value
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') pol(2) grid(90)
















******test option m()

cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(0) gen(yfiltered) deltap(`=deltap') deltam(`=deltam')
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(0) 


cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(-1) gen(yfiltered) deltap(`=deltap') deltam(`=deltam')
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(-1) 

**different values of M 
**bounds do not exist
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(0.0001) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(0.0001) grid(30 90)

**bounds are finite
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(0.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)
return list

cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(0.2) grid(30 90)
return list

**upper bound is infinity
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)
return list

cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) grid(30 90)
return list

**option M needs to be lower case
cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') M(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)









*********option numiter
cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') numiter(-1) grid(30 90)
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) numiter(-1) grid(30 90)

cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(1.56) grid(30 90)
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(1.56) grid(30 90)



cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(10) grid(30 90)
return list
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(10) grid(30 90)
return list




cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(1) grid(30 90)
return list
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(1) grid(30 90)
return list










********** option grid
cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(80(1)90)
return list
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(80(1)90)
return list


cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(70(.1)80)
return list
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(70(.1)80)
return list


cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(-10(10)50)
return list
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(-10(10)50)
return list





cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(80 85 to 90)
return list
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(80 85 to 90)
return list



cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(85/90)
return list
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(85/90)
return list



cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(90[-10]70)
return list
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(90[-10]70)
return list


cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(90 70 50)
return list
cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(90 70 50)
return list













***** option savingbounds
cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(90) savingbounds(dbounds)
return list



cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(90) savingbounds("dbounds")
return list





cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100)  grid(90) savingbounds(dbounds.dta)
return list





cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(90) savingbounds("dbounds.dta")
return list





cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(90)   savingbounds(dbounds)
return list




cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(90)   savingbounds(dbounds.dta)
return list


cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(90)   savingbounds("dbounds.dta")
return list








***** option savingtobit


cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(90)   savingtobit("dtobit.dta")
return list



cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(90)   savingtobit(dtobit)
return list








********* options saving tobit and bounds


cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(90) savingbounds(dbounds.dta) savingtobit(dtobit.dta)
return list


cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(90)   savingbounds(dbounds.dta) savingtobit(dtobit.dta)
return list









*********difference in return() with/out filter
cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(90) 
return list



cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) grid(90)   
return list









*********test option nopic
*note differences in return() with option nopic
cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(30 90) nopic 
return list



cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(30 90) nopic   
return list











*********test option binwidth
*error: not str positive
cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(30 90) binwidth(-.1) 
return list

cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(30 90) binwidth(-.1)    
return list

cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(30 90) binwidth(0) 
return list

cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(30 90) binwidth(0)    
return list

cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(30 90) binw(0.08) 
return list

cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(30 90) binw(0.08)    
return list


cap drop yfiltered
cap noisily bunching yfric 	x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(30 90) binw(0.08) nopic
return list

cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(30 90) binw(0.08) nopic
return list









 


********** varlist (and verbose)

cap drop yfiltered
cap noisily bunching ,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(30 90) binw(0.08) 
return list

cap noisily bunching ,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(30 90) binw(0.08)    
return list




cap drop yfiltered
cap noisily bunching yfric 	x*,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') n(100) grid(30 90) binw(0.08) verbose
return list

cap noisily bunching y x*,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) n(100) grid(30 90) binw(0.08) verbose
return list











*************** collinearity tests for tobit
*the friction error only exists plus and minus deltap,deltam  around the kink
scalar deltap = ln(1.1)
scalar deltam = -ln(0.9)



*kink location
scalar kink =  round(ln(8),0.0001)

**create grid 10(10)90 + 100
scalar ngrid_p = 9  
scalar max_p = 90  
scalar min_p = 10  
scalar bin_p = (max_p-min_p)/(ngrid_p-1)
matrix pctobs = J(ngrid_p,1,0)
matrix grid_h = J(ngrid_p,1,0)
gen temp = abs(y -`=kink')
forval i=1/`=ngrid_p' {
	scalar m = ngrid_p - (`i'-1)
	matrix pctobs[m,1]=round(min_p + bin_p*(`i'-1),1)	
	_pctile temp , percentiles(`=pctobs[m,1]')
	matrix grid_h[m,1]=`r(r1)'
}
qui sum temp 
scalar large_grid_h = 10 * r(max)
drop temp
matrix pctobs = 100\pctobs
matrix grid_h = (large_grid_h)\grid_h
scalar ngrid_p = ngrid_p + 1

***generate redundant covariates x3,x4,x5 to test the part of the code that drops collinear covariates
cap drop x4 x5 x6
**x3 should be dropped by two-sided tobit (pre-estimates stage)
gen x4 = x1+x2 
** x4 coef on this var should be constrained for trunc window #3
scalar h = grid_h[3,1]
gen x5 = rnormal()
replace x5 = x1+x2 if y<`=kink'+h & y>`=kink'-h
** x5 coef on this var should be constrained for trunc window #7
scalar h = grid_h[7,1]
gen x6 = rnormal()
replace x6 = x1+x2 if y<`=kink'+h & y>`=kink'-h


*scalar drop _all
*matrix drop _all


cap drop yfiltered
cap noisily bunching y x*,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2)    savingtobit(dtobit.dta, replace) verbose
return list
preserve
drop _all
cap use dtobit
list
restore





***using no covariates
cap drop yfiltered
cap noisily bunching yfric ,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam')   savingtobit(dtobit.dta, replace) verbose
return list
preserve
drop _all
cap use dtobit
list
restore


cap noisily bunching y,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2)  savingtobit(dtobit.dta, replace) nopic
return list
preserve
drop _all
cap use dtobit
list
restore


***using one covariate that gets dropped in initial estimates of tobit
gen x7=1
cap drop yfiltered
cap noisily bunching yfric x7,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') verbose grid(30 90)
return list


cap noisily bunching y x7,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2)  nopic grid(30 90)
return list



***************type float/double issue


count if yfiltered==`=kink'
gen float y_3 = yfiltered
count if y_3==`=kink'

cap noisily bunching y_3, k(`=kink') s0(`=s0') s1(`=s1') m(1.2)

*************** consistency without weights
*100K observations (measurement error added only to bunching individuals)


clear 
use bunching.dta



*kink location
scalar kink =  round(ln(8),0.0001)

cap drop yfiltered
cap noisily bunching yfric x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90) 
return list

cap noisily bunching y x1 x2 x3,  k(`=kink') s0(`=s0') s1(`=s1') m(2) grid(30 90)
return list






******no package lpdensity installed

*randomly select 10K observations
sample 10000, count

cap noisily ado dir
cap noisily ado uninstall lpdensity
 
cap drop yfiltered
cap noisily bunching yfric x1 x2,  k(`=kink') s0(`=s0') s1(`=s1') m(2) gen(yfiltered) deltap(`=deltap') deltam(`=deltam') grid(30 90)
cap noisily bunching y x1 x2,  k(`=kink') s0(`=s0') s1(`=s1') m(1.2) grid(30 90)

cap noisily net install lpdensity, from(https://sites.google.com/site/nppackages/lpdensity/stata) replace
